<?php

/*
 *  Functions and initialized variables
 *  Function TOC:
 *    +1+ var_set     See if a variable has been sent into the application, default it if not.
 *    +2+ auth_sql    Log onto the MySQL database.
 *    +3+ disp_fields The big one...shows fields of the db in an html form, either filled or not.
 *    +4+ list_opt    Create more form entries to set options (incl. a drop-down list for sort-by). 
 *    +5+ menu        The main menu (along the bottom of each page).
 *    +6+ nav_menu    The record navigation menu (VCR type controls).
 *    +7+ find_next   [used here only, in nav_menu()]
 *    +8+ trim_quotes [used by do_file() and do_submit() PROBABLY not needed here]
 *    +9+ find_last   used to locate the last record # 
 */  

// +1+
function var_set($var_name,$rtn=""){
  if (isset($_REQUEST[$var_name]))return $_REQUEST[$var_name];
  else return $rtn;
}  //end of var_set() 

// +1a+
function var_setB($var_name,$rtn=false){
  // var_set() does not work with booleans properly
  if ( isset($_REQUEST[$var_name]) ){
    if ($_REQUEST[$var_name]==""){ //default if blank
      return $rtn;
    }else{
      return $_REQUEST[$var_name];
    }
  }
  else return $rtn;
}  //end of var_setB()

// +2+
function auth_sql(){
  global $host,$reader,$password,$database;
  // open database
  mysql_connect($host,$reader,$password) or die("Oops! (connect)<br />");
  mysql_select_db($database) or die("Oops! (select)<br />");
} //end of auth_sql

// +3+
function disp_fields($fillIn,$data=array()){
  //produce table which shows most of the fields of the data base. 
  //Two versions are selectable: empty, or with data filled in.
  global $add_notes,$id,$user,$valid,$mode;
  global $show_fam,$classArray;
  if(!$fillIn){ 
    //NOT filled in with values, used by "Search" (look for...), "Enter" (create new)
    echo "
<table width='100%' border='0' cellspacing='3' cellpadding='3'>
  <tr>
    <td colspan='2'>
      part number:<br />
      <input type='text' name='type' size='25' maxlength='50' /><br />
      manufacturer:<br />
      <input type='text' name='manuf' size='25' maxlength='50' />
    </td>
    <td>
      pin count:<br />
      <input type='text' name='pins' size='7' maxlength='10' /><br />
      package:<br />
      <input type='text' name='pkg' size='7' maxlength='10' />
    </td>
    <td>description:<br />
      <textarea name='description' cols='35' rows='3'></textarea>
    </td>
  </tr>
  <tr>
    <td>
      classification:<br />
      <select name='class'>";
     foreach ($classArray as $key => $value){
       echo "<option value='$key'>$value</option>";
     }
    echo "
      </select><br />
      quantity:<br />
      <input type='text' name='qty' size='7' maxlength='10' />
    </td>
    <td>  
      location:<br />
      <input type='text' name='location' size='7' maxlength='10' />";
       if ($show_fam)
       echo "
      <br />
      family:<br />
      <input type='text' name='family' size='7' maxlength='10' />";
       echo "
    </td>
    <td colspan='2'>
      notes:<br />
      <textarea name='notes' cols='45' rows='1' /></textarea><br />
      disposition:<br />
      <textarea name='disposition' cols='45' rows='1' /></textarea>
    </td>
  </tr>
  <tr>";
  if ($mode=='Search' or $mode=='Look' or $mode==''){
    echo "
    <td colspan='4'>
      <input style='font-size:20px;font-weight:bold;color:red' type='submit' name='mode' value='Look'>
        ...for components matching these inputs.
    </td>
  </tr>
  <tr>";
  }
    if ( ($mode=='')){ //add in the "File" button only if at start
  echo"
    <td colspan='4'>
      <input style='font-size:20px;font-weight:bold;color:red' type='submit' name='mode' value='File'>
        ...away this as a new part.
    </td>
  </tr>";
    }
    echo "
</table>";
  }else{
  //IS filled in with values: Used by "Edit" mode
     extract($data);
     echo "
<table width='100%' border='0' cellspacing='3' cellpadding='3'>
  <tr>
    <td colspan='2'>
      part number:<br />
      <input type='text' name='type' size='25' maxlength='50' value='$type'/><br />
      manufacturer:<br />
      <input type='text' name='manuf' size='25' maxlength='50' value='$manuf'/>
    </td>
    <td>
      pin count:<br />
      <input type='text' name='pins' size='7' maxlength='10' value='$pins'/><br />
      package:<br />
      <input type='text' name='pkg' size='7' maxlength='10' value='$pkg'/>
    </td>
    <td>description:<br />
      <textarea name='description' cols='32' rows='3'>$description</textarea>
    </td>
  </tr>
  <tr>
    <td>
      classification:<br />
      <select name='class'>";
     foreach ($classArray as $key => $value){
       $sel = ($class == $key)?" selected='selected'":"";
       echo "\n       <option value='$key'{$sel}>$value</option>";
     }
     echo "
      </select><br />
      quantity:<br />
      <input type='text' name='qty' size='7' maxlength='10' value='$qty'/>
    </td>
    <td>
      location:<br />
      <input type='text' name='location' size='7' maxlength='10' value='$location'/>
    </td>
    <td colspan='2'>
      notes:<br />
      <textarea name='notes' cols='44' rows='1' />$notes</textarea><br />
      disposition:<br />
      <textarea name='disposition' cols='44' rows='1' />$disposition</textarea>
    </td>
  </tr>
  <tr>
    <td colspan='4' style='text-align:center;'>
      <input style='bg' type='hidden' name='mode' value='Submit'>
      <input style='font-size:20px;font-weight:bold;color:red' type='submit' value='Submit changes'>
      <input type='hidden' name='id' value='$id' />
      <span>[record #$id]</span>
    </td>
  </tr>
</table>";
  }
} //end of disp_fields()

// +4+    selectable options for search 
function list_opt(){
  global $add_notes,$id,$mode,$sortArray;
  echo "<h4>Options for tabular results (if more than one match found):</h4>
&nbsp;&nbsp;Show <span style='font-weight:bold'>description</span> field? 
<input type='checkbox' name='DescOn'  checked='checked' />
&nbsp;Show <span style='font-weight:bold'>disposition</span> field? 
<input type='checkbox' name='DispOn' />
&nbsp;Show <span style='font-weight:bold'>notes</span> field? 
<input type='checkbox' name='NotesOn' />";
  echo "<br />&nbsp;&nbsp;<span style='font-weight:bold'>Sort</span> by: <select name='sort'>";
  foreach ($sortArray as $key => $value){
    echo "<option value='$key'>$value";
  }
 echo "</select>";
} //end of list_opts()

// +5+     main menu. some buttons are optional
function menu(){ //menu at bottom.
  global $mode,$r; // $r is number of returns from search.
  echo "
  <div id='menu' >
    <form style='display:inline' action='index.php' method='post'>";
  if( $mode=="List" OR $mode=="Search" OR $mode=="" OR $mode=="Submit"){
    echo "
      <input type='submit' name='mode' value='Edit' /> a record, &nbsp;";
  }
  if( !($mode=="Search" OR $mode==""  OR ($mode=='Look' AND $r==0)) ){
    echo "
      <input type='submit' name='mode' value='Search' /> for parts, &nbsp;";
  }
    echo "
      <input type='submit' name='mode' value='Enter' /> a new part, &nbsp;
      <input type='submit' name='mode' value='List' /> all parts, &nbsp;
      <input type='submit' name='mode' value='Summarize' /> the data.
    </form>
  </div>";
} //end of menu

// +6+    VCR-style controls
function nav_menu($current_id,$last,$delete_option){ 
  global $valid,$mbg_arr,$menu_border;
  /* first record: */
  echo "
  <div style='text-align: center; padding-bottom:5px'>";
  $pid = find_next(true,$current_id,$last);
  if($pid>0){
    echo "
    <form style='display:inline;background url(LeftLeft.png)' action='index.php' method='post'>
      <input class='bg' style='background: url(LeftLeft.png) no-repeat center center' type='submit' value=' &nbsp; &nbsp; ' title='First entry' >
      <input type='hidden' name='mode' value='Edit' />
      <input type='hidden' name='id' value='1' />
    </form>";

  /* previous record */
    echo "
      <form style='display:inline' action='index.php' method='post'>
        <input class='bg' style='background: url(Left.png) no-repeat center center' type='submit' value=' &nbsp; &nbsp; ' title='Previous entry' >
        <input type='hidden' name='mode' value='Edit' />
        <input type='hidden' name='id' value='$pid' />
      </form>";
  }else{
    echo "
    <span class='bgx' style='background: url(LeftLeftX.png) no-repeat center center;' title='At the first entry!'>
      &nbsp; &nbsp; &nbsp; &nbsp;
    </span>
    <span class='bgx'  style='background: url(LeftX.png) no-repeat center center;' title='At the first entry!'>
      &nbsp; &nbsp; &nbsp; &nbsp;
    </span>";
  }

  /* delete record */
  if ($delete_option){
    echo "
      <form style='display:inline' action='index.php' method='post'>
        <input class='bg' style='background: url(Del.png) no-repeat center center' type='submit' value=' &nbsp; &nbsp; &nbsp; ' title='DELETE entry' />
        <input type='hidden' name='mode' value='Delete' />
        <input type='hidden' name='id' value='$current_id' />
      </form>";
  }
  
  /* next record */
  $nid  = find_next(false,$current_id,$last);
  if ($nid !==0){
    echo "
      <form style='display:inline' action='index.php' method='post'>
        <input class='bg' style='background: url(Right.png) no-repeat center center' type='submit' value=' &nbsp; &nbsp; ' title='Next entry' />
        <input type='hidden' name='mode' value='Edit' />
        <input type='hidden' name='id' value='$nid' />
      </form>";
  
    /* last record */
    echo "
      <form style='display:inline' action='index.php' method='post'>
        <input class='bg' style='background: url(RightRight.png) no-repeat center center' type='submit' value=' &nbsp; &nbsp; ' title='Last entry' />
        <input type='hidden' name='mode' value='Edit' />
        <input type='hidden' name='id' value='$last' />
      </form>";
  }else{
    echo "
    <span class='bgx' style='background: url(RightX.png) no-repeat center center;' title='At the last entry!'>
      &nbsp; &nbsp; &nbsp;&nbsp;</span>
    <span class='bgx' style='background: url(RightRightX.png) no-repeat center center;' title='At the last entry!'>
      &nbsp; &nbsp; &nbsp;&nbsp;</span>";
  }
  /* GoTo a record directly */
  echo "<div class='bg2' style='display:inline'>
    <form style='display:inline' action='index.php' method='post'>
      <input type='input'  size='5' maxlength='5' name='id' value='Go To' />
      <input class='bg3' style='background: url(GoTo.png) no-repeat center center' type='submit' value=' &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;' title='Jump To' />
      <input type='hidden' name='mode' value='Edit' />
    </form>    </div>
  </div>";  
} //end of nav_menu

// +7+
function find_next($back,$is,$max){ // find next or previous record (there could be holes)
  global $dbg,$table1;
  $query = "";
  $r = $is;
  if(!$back){
    //forwards
    $found = false;
    do {
      $r++;
      $query = "select * from $table1 where (ID=$r)";
      $result = mysql_query($query);
      if ($result == 0)
        echo("<b>Error " . mysql_errno() . ": " . mysql_error() . "</b>");
      $num_rows = mysql_num_rows($result);
      if ($num_rows==1)$found=true;
    }while (!$found AND $r<($max+2));
  }else{
    //back
    $found = false;
    do {
      $r--;
      $query = "select * from $table1 where (ID=$r)";
      $result = mysql_query($query);
      if ($result == 0)
        echo("<b>Error " . mysql_errno() . ": " . mysql_error() . "</b>");
      $num_rows = mysql_num_rows($result);
      if ($num_rows==1)$found=true;
    }while (!$found AND $r >0);
  }
  if (!$back and $r>$max) $r=0;
  return $r;
} //end of find_next

// +8+
function trim_quotes($str){
  //replace every " with two '
  return str_replace('"',"''",$str);
} //end of trim_quotes

// +9+
function find_last(){
  global $dbg,$table1;
  $q = "SELECT MAX(ID) FROM $table1 ";
  if ($dbg)echo "Query (find-last): $q <br />";
  $result = mysql_query($q);
  if ($result == 0){
    echo("<b>Error " . mysql_errno() . ": " . mysql_error() . "</b>");
    $last_id = 0;
  }else {
    $row = mysql_fetch_row($result);
    $last_id = $row[0];
  }
  return $last_id;
} //end of find_last
?>

