<?php 
 /*  (DOCTYPE below in case we want to use headers or cookies.)
  *
  *  Project 8501: use MySQL for a basic electronics component locator data base.
  *  
  *  Code sections (delineated by the selected cases of $mode)
  *   ""          start/re-start: same as "Search" but with "File" function too.   
  *   "Search"    Allow user to fill in an empty form with data to be searched for.
  *   "Look"      Do the searching with data from the "Search" form.
  *   "Enter"     Fill in form with a new record (i.e. a new component to be added to the db).
  *   "File"      Store the new entry, from "Enter", away in db.
  *   "Edit"      Allow user to change values of one or more fields of an existing record.
  *   "Submit"    Store away any changes made in "Edit".
  *   "Delete"    Remove a record. Only available from "Edit". 
  *   "List"      Produce a table with results from "Look", or all records if called from menu.
  *   "Summarize" Like it says!   
  */
  
///////////////////////////////////////////////////////////////////////////////////////////////////
 /* The assignments here Can Be, or Must Be, edited to define your installation: */ 
 // the data base:
  $user="root";      //The name of the user. Must have sufficient privleges to access the db.
  $host="localhost"; //Where the MySQL database lives. This can be "anywhere." 
  $password="";      //Obvious. Your security depends on it!
  $database="parts"; //Name of the databse. It must exist for the program to do anything. 
  $table1 = "parts"; //Name of the main (only, currently) table. If not found, it will be created.
  
 //some layout variables:
  $width = 700; //sets the display width (pixels)
  $padding = 5;   //the number of pixels within the border; blank space-think of matting for a photo
  $border = 10;   //the width of the border around the main stuff.
  //the colo(u)rs can be set as rgb(rr,gg,bb) OR #RRGGBB OR #RGB or by name, eg white.
  $background = "rgb(255,240,200)"; //used to set the background colour rgb(255,240,200) is a tan
  //This next variable shows up on the browser's top bar and the top of each page
  $title = "PLD Designs Electronics Components Data Base."; 
  
 //turn on|off the debug statements
  $dbg = false;   // true|false;
  
 //control the IMPORT_CSV mode
  //Note: to use the import feature, tack the string "?mode=IMPORT_CSV" onto the location 
  // line in the browser. Currently this is the only way to access the feature. 
  //Name of file to read:
  $import_file = 'file_name.csv';
  //The names of the fields, IN THE ORDER THEY ARE PRESENT IN THE INPUT FILE. Remove any fields
  // that are not used! Do not change the names, however, both the order and which ones are 
  // present can both be changed. If an index number is present it must be the first field and 
  // when present, it must be ignored...see the $ignore_first variable below.
  $import_field_list = 
     "location,type,family,manuf,qty,pkg,pins,description,notes,cost,disposition,class";
  //Often the first line of a CSV file contains the field names. If that is the case, ensure that
  // $skip_first_line is true, otherwise it should be false:
  $skip_first_line = false; // true|false;
  //This must be true when an index number exists: The index, which must be the first field,
  // must be skipped (numbers generated will be sequential):
  $ignore_first_col = true; // true|false;
  
 /* End of the generally changeable variables. Modify anything beyond here with increased risk! */
///////////////////////////////////////////////////////////////////////////////////////////////////

 // Initialize some arrays:
  // A method of handling table titles for multiple columns...it turns out that this can also
  // be done by SQL with an advanced query feature...try that later.
  
  // The titleArray is used to inform the software how to entitle the List table. The first two
  // arguments in one of the sub arrays indicate, respectively, how many fields are combined
  // and in which order. The third argument [2] is the tiltle to use. The fourth [3] arg is a 
  // descriptive string to put in query summaries instead of field names. The technique really
  // only applies to the package + pins column in the present program.
  // Note that this array is also used to determine whether an input variable (via get or post)
  // is in the set of variables which are in the data base. This is used anywhere a query needs
  // to be built with changed or new values for fields in the db. Look for the statement
  // "if (array_key_exists($key,$titleArray))" to see where this is used. Both uses of the array
  // mean that ONLY field names that exist in the data table can be keys.
  $titleArray = array('type'=>array(1,1,'Part Number','part number'),
                      'family'=>array(1,1,'','family'), //not used in current tables
                      'manuf'=>array(1,1,'Made by','manufacturer'),
                      'qty'=>array(1,1,'Qty','quantity'),
                      'location'=>array(1,1,'Bin #','bin'),
                      'pkg'=>array(2,1,'Package','package'),
                      'pins'=>array(2,2,'','pin count'),
                      'description'=>array(1,1,'Description','description'),
                      'disposition'=>array(1,1,'Disposition','disposition'),
                      'notes'=>array(1,1,'Notes','notes'),
                      'class'=>array(1,1,'Type','classification')
                     );
  
  // The classArray handles the one-letter code to name translation. The single letter code 
  // is stored in the data base, in the class field. To add a new classification, all that has to 
  // be done is to add another key => value pair to this array (don't forget the comma!). Anything 
  // here will appear in the drop-down list in the data forms and will be translated to in the 
  // list tables. The only restrictions: the keys must be unique and they must be a single
  // character long (upper/lower are different).  Changing this array does not present much risk.
  $classArray = array('X'=>"don't care",
                      'I'=>'IC',
                      'Q'=>'Transistor',
                      'D'=>'Diode',
                      'O'=>'Opto-electronic',
                      'L'=>'Inductor',
                      'C'=>'Capacitor',
                      'R'=>'Resistor',
                      'H'=>'Hardware',
                      'J'=>'Connector',
                      'P'=>'Package (box)',
                      'M'=>'Misc.'
                     );
                     
  // This array controls which fields are listed in a drop-down to control the sort order:
  $sortArray = array("type" => "Part Number",
                     "class" => "Component type",
                     "manuf" => "Manufacturer",
                     "qty" => "Quantity",
                     "location" => "Location (bin)"
                    ); //,"family" =>"Family" is not used
  
  include_once("include/pl_functions.php"); // the functions needed
  
  $mode = var_set('mode');   //main control variable
  
  //all the possible form fields:
  $id =  var_set('id');
  $type = var_set('type');
  $family = var_set('family');
  $manuf = var_set('manuf');
  $qty = var_set('qty');
  $location = var_set('location');
  $pkg = var_set('pkg');
  $pins = var_set('pins');
  $description = var_set('description');
  $disposition = var_set('disposition');
  $notes = var_set('notes');
  $class = var_set('class');
  $DescOn =  var_setB('DescOn',false); //show description (default on)
  $DispOn =  var_setB('DispOn',false); //show disposition
  $NotesOn =  var_setB('NotesOn',false); //show notes
  
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" 
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type" />
  <title><?php echo $title?> <?php echo $mode?></title>
  <?php
  //
  //Log onto MySql data base here...
  auth_sql();

  //check that table exists
  $q = "SHOW TABLES FROM $database LIKE '$table1'";
  $result = mysql_query($q)
     or die ("...but, can't get result!");
  $r = mysql_num_rows($result); 
  if ($r!==1){
    echo "<h1 style='color:red;background-color:white;'>Creating table $table1 since it does not exist!</h1>";
    $q = "CREATE TABLE $table1 (
          id int(6) NOT NULL default '0',
          location char(25) NOT NULL,
          type char(25) NOT NULL,
          family char(7) NOT NULL,
          manuf char(25),
          qty int(5) NOT NULL,
          pkg char(7) NOT NULL,
          pins char(7) NOT NULL,
          description varchar(150) NOT NULL default '',
          notes varchar(150),
          cost char(25),
          disposition varchar(150) NOT NULL,
          class char(1) NOT NULL default '',
          PRIMARY KEY (id)
          ) TYPE=MyISAM;";
    $result = mysql_query($q)or die ("Can't create table $table1!");
  }
  
  include("include/pl_topstuff.inc");  //html head & opens body & opens "main" div
  ?>
</head>

<body>
 <div id="main">
  <div>
     <h1><?php echo $title?></h1>
     <?php   
if ($dbg) {
  echo '(Debug) REQUEST variables are:<pre>';print_r($_REQUEST);echo '</pre>';
}
// The start of the action-specific code: //
switch ($mode):

case "":
case "Search":
  //present a form to fill out: (page display is slightly different depending on value of $mode)
  include('do_search.php');  //the blank form, mostly
  menu();
break;

case "Enter": //accept data to define a new component
  echo "
<h3>New: fill in the form with data for a new component...</h3>
<form action='index.php' method='post'>";
  disp_fields(false);
  echo "
  <input style='font-size:20px;font-weight:bold;color:red' type='submit' name='mode' value='File' />
    (Put the data in the data base)
  ";
  echo "
</form>";
  menu();
break;

case "File": //put the data away.
  include('do_file.php');
  menu();
break;

case "Edit":  //edit a record.
  $add_delete = false;
  include('do_edit.php'); 
  nav_menu($id,$last_id,$delete_opt); // $last_id & $delete_opt found in do_edit.php.
  menu();
break;

case "Submit": //put edited data back.
  include('do_submit.php'); 
  nav_menu($id,$last_id,true); // $last_id found in do_submit.php.
  menu();
break;

case "Delete": //delete a record.
  $query = "Delete from $table1 WHERE (id =$id)";
  $result = mysql_query($query);
  echo "<h3>record has been deleted</h3>";
  nav_menu($id,false,false);
  menu();
break;

case "Look": //search for the data from form that was filled in in the "Search" section:
  include('do_look.php');
  menu();
break;  //end of "Look"

case "List": //just show them all
  $sort = "none";
  $qual = "";
  echo "<h4>List of all components: "; //h4 is terminated in do_list.php
  $class_no_wild = false;
  $qty_no_wild = false;
  $loc_no_wild = false;
  include('do_list.php');
  menu();
break;  //end of "List"

case "Summarize": //
  echo "<h4>Summary of the $table1 table in the data base: </h4>";
  include('do_summary.php');
  menu();
break;  //end of "Summarize"

case "IMPORT_CSV":
  // doesn't prompt for a file, doesn't add at the end (just use for complete restore as it is)
  // only handles the file produced by the EXPORT_CSV since the field names are in that order.
  $file = $import_file;//'ICs23-Oct-2006.csv';
  if (!($file_h = fopen($file,"rb"))){
    echo "<b>Input file $file DID NOT OPEN...breaking</b><br />";
    break; 
  }
  $q = stripSlashes("SELECT MAX(id) FROM $table1");
  $result = mysql_query($q);
  if ($result == 0)
    echo("<b>Error in IMPORT_CSV:" . mysql_errno() . ": " . mysql_error() . "</b><br />");
  else {
    $row = mysql_fetch_row($result);
    $id = $row[0];
    $id++;
  }
  $id_init = $id;
  $f_list = explode(',',$import_field_list);

  //Read in lines from the file and process them
  while (($data = fgetcsv($file_h,1024)) !==false) { //(!feof($file_h)){
    if (!$skip_first_line){
      foreach($data as $key =>$value){
        $d[$key] = trim(str_replace('"','',$value)); 
      }
      $fields_to_use = "";
      $n = ($ignore_first_col)?1:0;
      foreach($f_list as $val){
       $fields_to_use .= ", \"{$d[$n]}\"";
       $n++;
      }
      $q = "INSERT INTO $table1 (id,$import_field_list) VALUES (\"$id\"$fields_to_use)";
      //    " VALUES ( \"$id\", \"$d[1]\", \"$d[2]\", \"$d[3]\", \"$d[4]\", \"$d[5]\", \"$d[6]\", \"$d[7]\", \"$d[8]\", \"$d[9]\", \"$d[10]\", \"$d[11]\", \"$d[12]\")";
      if ($dbg) echo "<br />[$id] Query (file import) is: $q";
      $result = mysql_query($q);
      if ($result == 0){
        echo("<b>Error " . mysql_errno() . ": " . mysql_error() . "</b>");
        break;
      }
      $id++;
    }
    $skip_first_line = false;
  }
  //close the file
  fclose($file_h);
  $loaded = $id - $id_init;
  echo "<b style='background-color:green;color:white;'>&nbsp; $loaded items loaded into $table1 &nbsp;</b><br />\n";
  menu();
break;

default:
  echo "
<h3 style='color:red;'>Invalid mode! ($mode)</h3>
<span style='color:red;margin-left:10em;font-weight:bold;'>&gt;&gt;&gt;&gt;&gt;&gt;
  <a href='$PHP_SELF' style='color:red;text-decoration:none;background-color:white;'>Re-start</a>
</span>";
  menu();
endswitch;

include("include/pl_bottomstuff.inc"); //terminates  <div id=main> <body> & <html>
  ?>
